/* Programme en mai-juin 1996 par Jean-Francois Lozevis
   Emulateur Spectrum 48 ko classique
   pour Linux avec architecture 386 */
# include <X11/Xlib.h>
# include <X11/Xutil.h>
# include <X11/Xos.h>
# include <stdio.h>

#include "spectrum.h"

void get_GC(Window win,GC *gc,XFontStruct *font_info);
void load_font(XFontStruct **font_info);
void TooSmall(Window win,GC gc,XFontStruct *font_info);
/*void draw_graphics(Window win,GC gc,unsigned window_width,
		   unsigned window_height);
void draw_text(Window win,GC gc,XFontStruct *font_info,
	       unsigned win_width,unsigned win_height); */

#define icon_bitmap_width 8
#define icon_bitmap_height 10

unsigned char icon_bitmap_bits[icon_bitmap_width*icon_bitmap_height/8]={
  0xFF,0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01,0xFF};

unsigned char mem[65537];
int executeZ80=0;
char *whichAttrsChanged[768+256*24];
# define BITMAPDEPTH 1

int raffraichit=1;
Display *display;
int screen;
GC gc;
Window win;

# define SMALL 1
# define OK 0

void main(int argc,char **argv)
{
  int nT=0,i;
  unsigned int width,height;
  int x=0,y=0,debug=0;
  unsigned int border_width=4;
  //  unsigned int display_width, display_height;
  char *window_name="Spectrum";
  char *icon_name="Spectrum";
  char *sna_name=NULL;
  Pixmap icon_pixmap;
  XSizeHints size_hints;
  XEvent report;
  XFontStruct *font_info=NULL;
  char *display_name=NULL;
  int iRaffraichit;
  // int window_size=0;
  if ((display=XOpenDisplay(display_name))==NULL)
    {
      fprintf(stderr,"spectrum: cannot connect to X server %s\n",
	      XDisplayName(display_name));
      exit(-1);
    }
  for (i=1;i<argc;i++) {
    if (argv[i][0]=='-')
      switch(argv[i][1]) {
      case 'h':
	printf("Spectrum Emulateur\n\t-h affiche cette aide\n\t-d mode debug\n\t-N ou N est 0 ou 1 pour la taille graphique\n\t-s son\n\t-Rn raffraichit toutes les n interruptions\n\t-c clavier \"Anglais\" pour certains jeux");
	exit(0);
      case 'c':
	typeclavier=1;
	break;
      case 'd':
	debug=1;
	break;
      case '0':
	Gmode=0;
	break;
      case '1':
	Gmode=1;
	break;
      case 's':
	yaduson=1;
	break;
      case 'R':
	raffraichit=argv[i][2]-'0';
	if (raffraichit<0 || raffraichit>9) raffraichit=1;
	break;
      default:
	printf("Unknown command: %c\n",argv[i][1]);
	exit(1);
      }
    else
      sna_name=argv[i];
  }
  {
    void InitDebogue(void);
    InitDebogue();
  }
  InitSpectrum(sna_name);
  if (debug)
    debogue();
  if (yaduson) {
    extern void InitSon(void);
    InitSon();
  }
  screen=DefaultScreen(display);
  //  display_width=DisplayWidth(display,screen);
  //  display_height=DisplayHeight(display,screen);
  width=256*(1+Gmode);height=192*(1+Gmode);
  win=XCreateSimpleWindow(display,RootWindow(display,screen),
			  x,y,width,height,border_width,
			  BlackPixel(display,screen),
			  WhitePixel(display,screen));
  icon_pixmap=XCreateBitmapFromData(display,win,icon_bitmap_bits,
				    icon_bitmap_width,icon_bitmap_height);
  size_hints.flags=PPosition | PSize | PMinSize;
  size_hints.x=x;
  size_hints.y=y;
  size_hints.width=width;
  size_hints.height=height;
  size_hints.min_width=width;
  size_hints.min_height=height;
  XSetStandardProperties(display,win,window_name,icon_name,
			  icon_pixmap,argv,argc,&size_hints);
  XSelectInput(display,win,ExposureMask | KeyPressMask | KeyReleaseMask
	       | ButtonPressMask);
  get_GC(win,&gc,font_info);
  XMapWindow(display,win);
  while(1)
    {
      Z80activite=0;
      pause();
      while (XCheckMaskEvent(display,
			     KeyPressMask | KeyReleaseMask
			     | ButtonPressMask | ExposureMask,
			     &report)
	     || XCheckTypedEvent(display,ClientMessage,&report)) {
	switch(report.type)
	  {
	  case ClientMessage:
	    if ((executeZ80&1)==0) {
	      for (iRaffraichit=0;iRaffraichit<raffraichit;iRaffraichit++) {
		nT+=70000;
		if (nT>20000)
		  nT=ExecZ80(nT);
		if (yaduson) {
		  extern void JoueSon(void);
		  JoueSon();
		}
	      }
	    }
	    // fprintf(stderr,"[%d]",nT);
	    DisplaySpectrum();
	    break;
	  case Expose:
	    {
	      int x,y,xm,ym;
	      xm=((((XExposeEvent *) &report)->x
		+((XExposeEvent *) &report)->width)+7)>>3;
	      xm=xm>32?32:xm;
	      ym=((((XExposeEvent *) &report)->y
		+((XExposeEvent *) &report)->height)+7)>>3;
	      ym=ym>24?24:ym;
	      for (y=((XExposeEvent *) &report)->y>>3;y<ym;y++)
		for (x=((XExposeEvent *) &report)->x>>3;x<xm;x++)
		  if (x<0 || y<0)
		    fprintf(stderr,"Z");
		  else
		  attrsChanged[y*32+x]=1;
	    }
	    break;
	  case KeyPress:
	  case KeyRelease:
	    {
	      extern void Z80HitKey(KeySym key,int bit);
	      KeyCode keycode=((XKeyEvent *) &report)->keycode;
	      Z80HitKey(XKeycodeToKeysym(display,keycode,0),
			report.type==KeyPress?0:1);
	      Z80HitKey(XKeycodeToKeysym(display,keycode,1),
			report.type==KeyPress?0:1);
	    }
	    break;
	  case ButtonPress:
	    XFreeGC(display,gc);
	    exit(0);
	  default:
	    break;
	  }
      }
    }
}

void get_GC(Window win,GC *gc,XFontStruct *font_info)
{
  unsigned long valuemask=0;
  XGCValues values;
  *gc=XCreateGC(display,win,valuemask,&values);
  XSetForeground(display,*gc,BlackPixel(display,screen));
}

